## org.mortbay.servlet
Class ThrottlingFilter

    java.lang.Object
      org.mortbay.servlet.ThrottlingFilter

All Implemented Interfaces:
  javax.servlet.Filter

    public class ThrottlingFilter

extends java.lang.Object
implements javax.servlet.Filter

This filter protects a web application from having to handle an unmanageable load.

For servers where there is 1 application with standardized resource restrictions, then this affect can be easily controlled by limiting the size of the `server thread pool`, however where there are multiple applications, or a single application has different resource requirements for different URLs, then this filter can assist in managing the number of requests being services at any point in time.

The filter has 3 configurable values, which may be set as init parameters:

1. `maximum` determines the maxmimum number of requests that may be on the filter chain at any point in time. (See below for a more detailed explanation)
2. `block` determines how long (in milliseconds) a request will be queued before it is rejected. Set this to -1 to block indefinately.
3. `queue` determines how many requests can be queued simultaneously - any additional requests will be rejected. Set this to 0 to turn off queueing.

Request Counting: The filter counts how many requests are currently being services by the rest of the filter chain (including any servlets that may be configured to handle the request). Request counting is per instance of the filter. There is no syncronization between virtual machines, and the request count is not shared between multiple instances of the filter. Thus a web.xml file such as

      <filter><filter-name>throttle1</filter-name>
              <filter-class>org.adjective.spiral.filter.ThrottlingFilter</filter-class>
      <filter><filter-name>throttle2</filter-name>
              <filter-class>org.adjective.spiral.filter.ThrottlingFilter</filter-class>

creates 2 separate filters with individual request counts.

Queueing: When the number of active requests exceed the `maximum` requests will be queued. This queue regulates the flow of connections. Once the number of requests on the queue reached the `queue` threshold, then any new requests will be rejected. Requests are queued for a maximum of `block` milliseconds - is no capacity is made available in this time then the request will be rejected. The oldest pending request is removed from the queue and processed as soon as the number of pending requests falls below the `maximum` value (i.e. when a request is completed)

Rejection: Requests are rejected when the number of requests in progress has reached maximum and either the queue is full; or a request has been queued for more than `block` milliseconds. The rejection is performed by calling the method `rejectRequest(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)`. By default this method sends the HTTP status code `503`, but this may be over-ridden in derived classes.

This filter works best with the `SelectChannelConnector`, as `RetryRequest` based `Continuation`s can be used to free the thread and other resources associated with the queued requests.

Author:
  - Tim Vernum

Constructor Summary
`ThrottlingFilter()`

Method Summary
`void` `destroy()`
`void` `doFilter(javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response, javax.servlet.FilterChain chain)`
`void` `doFilter(javax.servlet.ServletRequest request, javax.servlet.ServletResponse response, javax.servlet.FilterChain chain)`
`void` `init(javax.servlet.FilterConfig filterConfig)`
`protected void` `rejectRequest(javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ThrottlingFilter

    public ThrottlingFilter()

Method Detail

### init

    public void init(javax.servlet.FilterConfig filterConfig)
              throws javax.servlet.ServletException

  Specified by:
    `init` in interface `javax.servlet.Filter`
  Throws:
    `javax.servlet.ServletException`

### doFilter

    public void doFilter(javax.servlet.ServletRequest request,
                         javax.servlet.ServletResponse response,
                         javax.servlet.FilterChain chain)
                  throws java.io.IOException,
                         javax.servlet.ServletException

  Specified by:
    `doFilter` in interface `javax.servlet.Filter`
  Throws:
    `java.io.IOException`
    `javax.servlet.ServletException`

### doFilter

    public void doFilter(javax.servlet.http.HttpServletRequest request,
                         javax.servlet.http.HttpServletResponse response,
                         javax.servlet.FilterChain chain)
                  throws java.io.IOException,
                         javax.servlet.ServletException

  Throws:
    `java.io.IOException`
    `javax.servlet.ServletException`

### rejectRequest

    protected void rejectRequest(javax.servlet.http.HttpServletRequest request,
                                 javax.servlet.http.HttpServletResponse response)
                          throws java.io.IOException

  Throws:
    `java.io.IOException`

### destroy

    public void destroy()

  Specified by:
    `destroy` in interface `javax.servlet.Filter`

Copyright © 1995-2010 Mort Bay Consulting. All Rights Reserved.